// dummy class implementation .cpp

#include "dummy.h"
#include <string.h>

// ctor
Array::Array()
{
	m_array = new char [5];
	m_quantity = 5;
	m_point=0;
	for (int i=0; i<5; ++i)
		m_array[i] = NULL;
}

// dtor
Array::~Array()
{
	delete [] m_array;
}

// cctor
Array::Array(const Array &other)
{
	m_quantity = other.m_quantity;
	m_point = other.m_point;
	m_array = new char [m_quantity+1];
	for (int i=0; i<m_quantity; ++i)
		{ m_array[i] = other.m_array[i]; }
}


// oper=
Array &Array::operator= (const Array &other)
{
	if (this == &other)				// compare the pointer !!
	  return *this;		

	if (m_array) delete [] m_array;
	
	m_quantity = other.m_quantity;
	m_point = other.m_point;
	m_array = new char [m_quantity+1];
	for (int i=0; i<m_quantity; ++i)
		{ m_array[i] = other.m_array[i]; }

	return *this;
}

// oper==
BOOL Array::operator== (const Array &other) const
{
	//int size = (m_quantity < other.m_quantity ? m_quantity : other.m_quantity);

	if (m_quantity != other.m_quantity)
		return FALSE;

	for (int i=0; i<m_quantity; ++i)
	{
		if ( !(m_array[i] == other.m_array[i]) )
			return FALSE;
	}

	return TRUE;
}

// oper!=
BOOL Array::operator!= (const Array &other) const
{
	if (*this == other)
		return FALSE;
	else 
		return TRUE;
}



// oper[]
char &Array::operator[] (int index)
{
	if ( (index < 1) || (index > m_quantity) )
		return m_array[0];

	return m_array[index-1];
}


// Add
void Array::Add(char element)
{
	if (m_quantity < 1) 
		return;
	
	if ( m_point == m_quantity)
		Add_5_Element();

	m_array[m_point] = element;
	m_point++;	
}


// Add entire array
void Array::Add(char *array, int number)
{
	if (number < 1)
		return;

	while ( number > (m_quantity - m_point) )
		Add_5_Element();

	int temp = m_point;
	for (int i=temp; i<(temp + number); ++i)
	{
		m_array[i] = array[i-temp];
		m_point++;
	}
}


// Add more array elment
void Array::Add_5_Element(void)
{
	char *temp = new char [m_quantity+1]; 
	for (int i=0; i<m_point; ++i)
		temp[i] = m_array[i];

	delete [] m_array;

	m_quantity += 5;
	m_array = new char [m_quantity+1];
		
	for (i=0; i<m_point; ++i)
		m_array[i] = temp[i];
	for (i=m_point; i<m_quantity; ++i)
		m_array[i] = 0;

	delete [] temp;

}


// Remove
void Array::Remove(int index)
{
	for (int i=index; i<m_point; ++i)
		m_array[i-1] = m_array[i];
	
	m_array[i-1] = 0;
}

// Search
BOOL Array::Search(char element) const
{
	for (int i=0; i<m_point; ++i)
	{
		if ( m_array[i] == element )
			return TRUE;
	}

	return FALSE;
}



// ostream op<<
ostream &operator<< (ostream &output, const Array &other)
{
	if (other.m_quantity == 0)
		return output;
	for (int i=0; i<other.m_quantity; ++i)
	{
		output << other.m_array[i];
		if (i<other.m_quantity-1)
			{cout << ",";}
	}

	return output;
}